Core - Bug # 40653

Task # 40095 (Resolved): Move core to namespaces

Status: Resolved Priority: Must have
Author: Nicole Cordes Category:

Created: 2012-09-05 Assigned To:

Updated: 2013-03-01 Due date:

TYPOS3 Version: 6.0

PHP Version:

Complexity:

Is Regression:
Sprint Focus:

Subject: Namespace interfaces don't work for PHP version < 5.3.7 due to type hinting issues

Description

Fatal errors are thrown when using an old interface with the new TYPOS3 6.0 beta 1. This only happens with PHP versions below 5.3.7
and ends in something like that:

Fatal error: Declaration of tx_extdevevalDevLinks::__construct() must be compatible with that of
TYPO3\CMS\Backend\Toolbar\ToolbarltemHookInterface::__construct() in
/...ltypo3conf/ext/extdeveval/class.tx_extdeveval_additionalBackendltems.php

on line 34

Related issues:

related to Advanced Frontend Editing - Bug # 40773: Fatal error due to change... Closed 2012-09-09
related to Core - Bug # 40951: Rename autoloader class Closed 2012-09-16
related to Core - Bug # 43451: Existing implementation of txCmsLayoutDrawltem... Closed 2012-11-29

Associated revisions

Revision ceb6d707 - 2012-09-18 19:51 - Nicole Cordes

[BUGFIX] Fatal errors for interfaces with PHP version < 5.3.7

This bugfix rewrites function type hints to match the new ones as long as
PHP versions of OS Venders are not up to date.

Fatal errors are thrown when using an old interface with the new

TYPOS 6.0 beta 1. This only happens with PHP versions below 5.3.7 as
there are some type hinting issues.

Raise the Extbase submodule pointer at the same time to be in line
with the renaming of the Autoloader to ClassLoader.

Change-Id: I187da4bb2ef0420a94d1d155edde500c1aa96894a
Fixes: #40653

Related: #40095

Releases: 6.0

Reviewed-on: http://review.typo3.org/14376

Reviewed-by: Helmut Hummel
Tested-by: Helmut Hummel

History
#1 - 2012-09-05 15:17 - Gerrit Code Review

- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.

It is available at http://review.typo3.0rg/14376

#2 - 2012-09-05 15:44 - Thomas Maroschik
- Assigned To set to Thomas Maroschik

I'm going to take care of this one.

#3 - 2012-09-09 16:46 - Christian Kuhn

- Parent task set to #40095

#4 - 2012-09-11 19:15 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.

It is available at http://review.typo3.org/14376

#5 - 2012-09-11 19:22 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.

It is available at http://review.typo3.0rg/14376

#6 - 2012-09-16 22:01 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.

It is available at http://review.typo3.org/14376

#7 - 2012-09-18 19:25 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.

It is available at http://review.typo3.org/14376

#8 - 2012-09-18 19:42 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.

It is available at http://review.typo3.0rg/14376

#9 - 2012-09-18 20:30 - Nicole Cordes
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

2015-08-04

2/3


http://review.typo3.org/14376
http://review.typo3.org/14376
http://review.typo3.org/14376
http://review.typo3.org/14376
http://review.typo3.org/14376
http://review.typo3.org/14376

Applied in changeset commit:ceb6d7075458c2647e8132b2be7d62949784fb14.

#10 - 2012-11-28 09:42 - Ernesto Baschny
- Status changed from Resolved to Accepted
- Target version changed from 6.0.0-beta2 to 6.0.1

Sorry, to re-open this issue, but this is not solved yet in 6.0.0. | am still getting the "Fatal error" as described in the description under Debian Squeeze

after installing extdeveval from TER.

| will further investigate.

#11 - 2012-11-29 14:06 - Ernesto Baschny

- Status changed from Accepted to Resolved

- Target version deleted (6.0.1)

Indeed sadly there is nothing the core can do about it. A small fix needs to be included in the extension that has this problem, see solution for

extdeveval here: #43444.

The solution is simple:

1) Make sure you register your toobarltem in a php file which does not include the class definition itself. The registration PHP file should only call the
"$GLOBALS['TYPO3backend']->addToolbarltem" method.

2) Make sure the class you are declaring as an implementation of "backend_toolbarltem" can be properly auto-loaded by TYPO3.

If these two conditions are met, your toolbarltem will work without a problem in TYPO3 4.5 throughout 6.0.

So closed again.

#12 - 2013-03-01 17:01 - Michael Stucki
- Assigned To deleted (Thomas Maroschik)

| have reported the problem to Debian and hope they are going to backport the fix:
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=702004
